
/*
Copyright (c) 2004, Datagrove, Inc.
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
    * Neither the name of the Datagrove, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers
#include <windows.h>
#include <Oleacc.h>

#define MOZILLA_STRICT_API
#define XP_WIN
#include <nsIGenericFactory.h>
#include <nsCOMPtr.h>

#include "itpctip.h"

HBITMAP mBitmap;
VOID CALLBACK WinEventProc(
  HWINEVENTHOOK hWinEventHook,
  DWORD event,
  HWND hwnd,
  LONG idObject,
  LONG idChild,
  DWORD dwEventThread,
  DWORD dwmsEventTime
)
{
	static HWND gWnd;
	static POINT p;

	IAccessible* pacc;
	VARIANT var;
	if (S_OK!=AccessibleObjectFromEvent(hwnd,idObject,idChild,&pacc,&var))
		return;
	if (event==EVENT_OBJECT_LOCATIONCHANGE)
	{
		if (idObject == 0)
			::SetCaretPos(p.x,p.y);
		else if (idObject == OBJID_CARET)
		{
			VARIANT v,vr; v.vt = VT_I4; v.lVal = CHILDID_SELF;
			pacc->get_accRole(v,&vr);

			// cursor moved!
			if (vr.lVal = ROLE_SYSTEM_CARET)
			{
				if (gWnd!=hwnd)
				{
					DestroyCaret();
					gWnd = hwnd;
#ifdef _DEBUG
					::CreateCaret(hwnd,0 ,10,10);
#else
					::CreateCaret(hwnd,mBitmap,0,0);
#endif
					::ShowCaret(hwnd);
				}

				long w,h;
				pacc->accLocation(&p.x,&p.y,&w,&h,v);
				// Convert Screen to window coordinates
				ScreenToClient(hwnd,&p);
				::SetCaretPos(p.x,p.y);
			}
		}
	}
	pacc->Release();

}
BOOL APIENTRY DllMain( HMODULE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	static HWINEVENTHOOK hook;
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		{			
		int d=0;
		mBitmap = CreateBitmap(1,1,1,1,&d);

		hook = SetWinEventHook(
			EVENT_MIN ,
			EVENT_MAX,
			hModule,
			WinEventProc,
			GetCurrentProcessId(),
			0,
			WINEVENT_INCONTEXT
			);
		}
		break;
	case DLL_PROCESS_DETACH:
		UnhookWinEvent(hook);
		break;
	}
    return TRUE;
}
class dgTpcTip : public iTpctip
{
public:
  NS_DECL_ISUPPORTS;
  NS_DECL_ITPCTIP;

  dgTpcTip(){}

private:

	~dgTpcTip(){}

};
NS_IMETHODIMP dgTpcTip::Noop()
{
	return NS_OK;
}

NS_IMPL_ISUPPORTS1(dgTpcTip, iTpctip	) // nsISelectionListener,nsIDOMFocusListener)


// {724E4A84-5B98-4de5-BCD3-06BA982DDB4E}
#define DG_TPCTIP_CID {	0xc550d19a, 0x7a16, 0x411e, 0xb3, 0xbd, 0xf5, 0xbf, 0x7e, 0x26, 0x50, 0x11 }

NS_GENERIC_FACTORY_CONSTRUCTOR(dgTpcTip);
static const nsModuleComponentInfo components[] =
{
	{ "TPC TIP",
	DG_TPCTIP_CID,
	"@datagrove.com/tpctip",
	dgTpcTipConstructor
	}
};
NS_IMPL_NSGETMODULE(nsTpcTipModule, components)







